# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTIBILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

bl_info = {
    "name" : "ImportDepthMap",
    "author" : "Elin", 
    "description" : "",
    "blender" : (3, 0, 0),
    "version" : (1, 0, 3),
    "location" : "Tool",
    "warning" : "",
    "doc_url": "", 
    "tracker_url": "", 
    "category" : "3D View" 
}


import bpy
import bpy.utils.previews
import os
from bpy_extras.io_utils import ImportHelper, ExportHelper
import math


addon_keymaps = {}
_icons = None
nodetree = {'sna_image': None, 'sna_depthimage': None, 'sna_normalempty': None, 'sna_aspectratio': 0.0, 'sna_usesepimages': False, }


def sna_subsurfsettings_8C39B(Name, Levels, Type, Index):
    bpy.context.view_layer.objects.active.modifiers.values()[Index].name = Name
    bpy.context.view_layer.objects.active.modifiers.values()[Index].subdivision_type = Type
    bpy.context.view_layer.objects.active.modifiers.values()[Index].render_levels = Levels
    bpy.context.view_layer.objects.active.modifiers.values()[Index].levels = Levels


def sna_materialsetup_AC51B():
    bpy.ops.object.material_slot_add('INVOKE_DEFAULT', )
    material_F46A0 = bpy.data.materials.new(name=nodetree['sna_image'].name, )
    material_F46A0.use_nodes = True
    bpy.context.object.active_material = material_F46A0
    node_A7B06 = material_F46A0.node_tree.nodes.new(type='ShaderNodeTexImage', )
    node_A7B06.location = (-300.0, 100.0)
    node_A7B06.image = nodetree['sna_image']
    material_F46A0.node_tree.nodes['Principled BSDF'].inputs['Roughness'].default_value = 0.9900000095367432
    material_F46A0.node_tree.nodes['Principled BSDF'].inputs['Specular'].default_value = 0.009999999776482582
    link_B8FF1 = material_F46A0.node_tree.links.new(input=material_F46A0.node_tree.nodes['Principled BSDF'].inputs[0], output=node_A7B06.outputs[0], )
    link_F8C6B = material_F46A0.node_tree.links.new(input=material_F46A0.node_tree.nodes['Principled BSDF'].inputs['Emission'], output=node_A7B06.outputs[0], )
    if nodetree['sna_usesepimages']:
        pass
    else:
        node_4DD1D = material_F46A0.node_tree.nodes.new(type='ShaderNodeMapping', )
        node_4DD1D.location = (-500.0, 100.0)
        link_BF94B = material_F46A0.node_tree.links.new(input=node_A7B06.inputs[0], output=node_4DD1D.outputs[0], )
        node_125D2 = material_F46A0.node_tree.nodes.new(type='ShaderNodeTexCoord', )
        node_125D2.location = (-700.0, 100.0)
        link_0752D = material_F46A0.node_tree.links.new(input=node_4DD1D.inputs[0], output=node_125D2.outputs[2], )
        node_4DD1D.inputs['Scale'].default_value = (0.5, 1.0, 1.0)


def sna_add_to_topbar_mt_file_import_836F3(self, context):
    if not (False):
        layout = self.layout
        op = layout.operator('sna.load_image_ae495', text='Import Depth Map', icon_value=0, emboss=True, depress=False)
        op.sna_seperate_depth_map = False


class SNA_OT_Load_Image_Ae495(bpy.types.Operator, ImportHelper):
    bl_idname = "sna.load_image_ae495"
    bl_label = "Load Image"
    bl_description = "Load combined color and depth image or:"
    bl_options = {"REGISTER", "UNDO"}
    filter_glob: bpy.props.StringProperty( default='*.png;*.jpg;*.exr', options={'HIDDEN'} )
    sna_seperate_depth_map: bpy.props.BoolProperty(name='Seperate Depth Map', description='Select a seperate depth map', default=False)

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        image_736E6 = bpy.data.images.load(filepath=self.filepath, )
        nodetree['sna_usesepimages'] = self.sna_seperate_depth_map
        nodetree['sna_image'] = image_736E6
        nodetree['sna_aspectratio'] = (image_736E6.size[0] / image_736E6.size[1] if nodetree['sna_usesepimages'] else image_736E6.size[0] / 2.0 / image_736E6.size[1])
        if nodetree['sna_usesepimages']:
            bpy.ops.sna.load_depth_image_ec8b8('INVOKE_DEFAULT', )
        else:
            sna_buildsetup_63DA1()
        return {"FINISHED"}


class SNA_OT_Load_Depth_Image_Ec8B8(bpy.types.Operator, ImportHelper):
    bl_idname = "sna.load_depth_image_ec8b8"
    bl_label = "Load Depth Image"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}
    filter_glob: bpy.props.StringProperty( default='*.png;*.jpg;*.exr', options={'HIDDEN'} )

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        image_DC27F = bpy.data.images.load(filepath=self.filepath, )
        nodetree['sna_depthimage'] = image_DC27F
        sna_buildsetup_63DA1()
        return {"FINISHED"}


def sna_buildsetup_63DA1():
    bpy.ops.object.empty_add('INVOKE_DEFAULT', type='SINGLE_ARROW', radius=0.30000001192092896, location=(0.0, -2.0, 0.0), rotation=(math.radians(-90.0), 0.0, 0.0))
    nodetree['sna_normalempty'] = bpy.context.view_layer.objects.active
    bpy.context.view_layer.objects.active.name = nodetree['sna_image'].name.split(',')[0] + '_Align'
    bpy.ops.mesh.primitive_plane_add('INVOKE_DEFAULT', size=1.0)
    bpy.context.view_layer.objects.active.name = nodetree['sna_image'].name.split(',')[0]
    bpy.ops.object.shade_smooth('INVOKE_DEFAULT', use_auto_smooth=True, auto_smooth_angle=math.radians(60.0))
    bpy.context.view_layer.objects.active.rotation_euler = (math.radians(90.0), 0.0, 0.0)
    bpy.context.view_layer.objects.active.location = (0.0, 0.0, 0.5)
    bpy.context.view_layer.objects.active.scale = (nodetree['sna_aspectratio'], 1.0, 1.0)
    bpy.ops.object.transform_apply('INVOKE_DEFAULT', location=True, rotation=True, scale=True)
    bpy.ops.object.modifier_add('INVOKE_DEFAULT', type='SUBSURF')
    sna_subsurfsettings_8C39B('SIMPLE Subsurf', 6, 'SIMPLE', 0)
    bpy.ops.object.modifier_add('INVOKE_DEFAULT', type='NORMAL_EDIT')
    sna_normaleditsettings_DF45C(1)
    bpy.ops.object.modifier_add('INVOKE_DEFAULT', type='DISPLACE')
    sna_setdisplacesettings_E5830(2)
    bpy.ops.object.modifier_add('INVOKE_DEFAULT', type='SUBSURF')
    sna_subsurfsettings_8C39B('Smooth Subsurf', 1, 'CATMULL_CLARK', 3)
    sna_materialsetup_AC51B()


def sna_setdisplacesettings_E5830(Index):
    bpy.context.view_layer.objects.active.modifiers.values()[Index].texture_coords = 'UV'
    bpy.context.view_layer.objects.active.modifiers.values()[Index].direction = 'CUSTOM_NORMAL'
    texture_F90B3 = bpy.data.textures.new(name='DepthDisplace', type='IMAGE', )
    bpy.context.view_layer.objects.active.modifiers.values()[Index].texture = texture_F90B3
    texture_F90B3.extension = 'CLIP'
    if nodetree['sna_usesepimages']:
        texture_F90B3.image = nodetree['sna_depthimage']
    else:
        texture_F90B3.image = nodetree['sna_image']
        bpy.context.view_layer.objects.active.modifiers.values()[Index].texture.crop_min_x = 0.5


def sna_normaleditsettings_DF45C(Index):
    bpy.context.active_object.modifiers[Index].target = nodetree['sna_normalempty']
    bpy.context.view_layer.objects.active.modifiers.values()[Index].mode = 'DIRECTIONAL'


def register():
    global _icons
    _icons = bpy.utils.previews.new()
    bpy.types.TOPBAR_MT_file_import.append(sna_add_to_topbar_mt_file_import_836F3)
    bpy.utils.register_class(SNA_OT_Load_Image_Ae495)
    bpy.utils.register_class(SNA_OT_Load_Depth_Image_Ec8B8)


def unregister():
    global _icons
    bpy.utils.previews.remove(_icons)
    wm = bpy.context.window_manager
    kc = wm.keyconfigs.addon
    for km, kmi in addon_keymaps.values():
        km.keymap_items.remove(kmi)
    addon_keymaps.clear()
    bpy.types.TOPBAR_MT_file_import.remove(sna_add_to_topbar_mt_file_import_836F3)
    bpy.utils.unregister_class(SNA_OT_Load_Image_Ae495)
    bpy.utils.unregister_class(SNA_OT_Load_Depth_Image_Ec8B8)
